## packetfence-8.3.0.tar.gz

=== Makefile ===
DOCBOOK_XSL := /usr/share/xml/docbook/stylesheet/docbook-xsl
UNAME := $(shell uname -s)
ifeq ($(UNAME),Darwin)
	DOCBOOK_XSL := /opt/local/share/xsl/docbook-xsl
else ifneq ("$(wildcard /etc/redhat-release)","")
	DOCBOOK_XSL := /usr/share/sgml/docbook/xsl-stylesheets
endif

all:
	@echo "Please chose which documentation to build:"
	@echo ""
	@echo " 'pdf' will build all guides using the PDF format"
	@echo " 'PacketFence_Installation_Guide.pdf' will build the Installation guide in PDF"
	@echo " 'PacketFence_Clustering_Guide.pdf' will build the Clustering guide in PDF"
	@echo " 'PacketFence_Developers_Guide.pdf' will build the Developers guide in PDF"
	@echo " 'PacketFence_Network_Devices_Configuration_Guide.pdf' will build the Network Devices Configuration guide in PDF"

pdf: docs/docbook/xsl/titlepage-fo.xsl docs/docbook/xsl/import-fo.xsl $(patsubst %.asciidoc,%.pdf,$(notdir $(wildcard docs/PacketFence_*.asciidoc)))

docs/docbook/xsl/titlepage-fo.xsl: docs/docbook/xsl/titlepage-fo.xml
	xsltproc \
		-o docs/docbook/xsl/titlepage-fo.xsl \
		$(DOCBOOK_XSL)/template/titlepage.xsl \
		docs/docbook/xsl/titlepage-fo.xml

docs/docbook/xsl/import-fo.xsl:
	@echo "<?xml version='1.0'?> \
	<xsl:stylesheet   \
	  xmlns:xsl=\"http://www.w3.org/1999/XSL/Transform\" \
	  xmlns:fo=\"http://www.w3.org/1999/XSL/Format\" \
	  version=\"1.0\"> \
	  <xsl:import href=\"${DOCBOOK_XSL}/fo/docbook.xsl\"/> \
	</xsl:stylesheet>" \
	> docs/docbook/xsl/import-fo.xsl

%.pdf : docs/%.asciidoc docs/docbook/xsl/titlepage-fo.xsl docs/docbook/xsl/import-fo.xsl
	asciidoc \
		-a docinfo2 \
		-b docbook \
		-d book \
		-f docs/docbook/docbook45.conf \
		-o docs/docbook/$(notdir $<).docbook \
		$<
	xsltproc \
		-o $<.fo \
		docs/docbook/xsl/packetfence-fo.xsl \
		docs/docbook/$(notdir $<).docbook
	fop \
		-c docs/fonts/fop-config.xml \
		$<.fo \
		-pdf docs/$@

html: $(patsubst %.asciidoc,%.html,$(notdir $(wildcard docs/PacketFence_*.asciidoc)))

%.html : docs/%.asciidoc
	asciidoctor \
		-D docs/html \
		-n \
		-a imagesdir=../images \
		$<

html/pfappserver/root/static/doc:
	make html
	cp -a docs/html/* html/pfappserver/root/static/doc
	cp -a docs/images/* html/pfappserver/root/static/images

pfcmd.help:
	/usr/local/pf/bin/pfcmd help > docs/pfcmd.help

.PHONY: configurations

configurations:
	find -type f -name '*.example' -print0 | while read -d $$'\0' file; do cp -n $$file "$$(dirname $$file)/$$(basename $$file .example)"; done
	touch /usr/local/pf/conf/pf.conf

.PHONY: configurations_force

configurations_hard:
	find -type f -name '*.example' -print0 | while read -d $$'\0' file; do cp $$file "$$(dirname $$file)/$$(basename $$file .example)"; done
	touch /usr/local/pf/conf/pf.conf

# server certs and keys
# the | in the prerequisites ensure the target is not created if it already exists
# see https://www.gnu.org/software/make/manual/make.html#Prerequisite-Types
conf/ssl/server.pem: | conf/ssl/server.key conf/ssl/server.crt conf/ssl/server.pem 
	cat conf/ssl/server.crt conf/ssl/server.key > conf/ssl/server.pem

conf/ssl/server.crt: | conf/ssl/server.crt
	openssl req -new -x509 -days 365 \
	-out /usr/local/pf/conf/ssl/server.crt \
	-key /usr/local/pf/conf/ssl/server.key \
	-config /usr/local/pf/conf/openssl.cnf

conf/ssl/server.key: | conf/ssl/server.key
	openssl genrsa -out /usr/local/pf/conf/ssl/server.key 2048

conf/local_secret:
	date +%s | sha256sum | base64 | head -c 32 > /usr/local/pf/conf/local_secret

conf/unified_api_system_pass:
	date +%s | sha256sum | base64 | head -c 32 > /usr/local/pf/conf/unified_api_system_pass

bin/pfcmd: src/pfcmd.c
	$(CC) -O2 -g -std=c99  -Wall $< -o $@

bin/ntlm_auth_wrapper: src/ntlm_auth_wrap.c
	cc -g -std=c99  -Wall  src/ntlm_auth_wrap.c -o bin/ntlm_auth_wrapper

.PHONY:permissions

/etc/sudoers.d/packetfence.sudoers: packetfence.sudoers
	cp packetfence.sudoers /etc/sudoers.d/packetfence

.PHONY: sudo

sudo: /etc/sudoers.d/packetfence.sudoers


permissions: bin/pfcmd
	./bin/pfcmd fixpermissions

raddb/certs/server.crt:
	cd raddb/certs; make

.PHONY: raddb-sites-enabled

raddb/sites-enabled:
	mkdir raddb/sites-enabled
	cd raddb/sites-enabled;\
	for f in packetfence packetfence-tunnel dynamic-clients;\
		do ln -s ../sites-available/$$f $$f;\
	done

.PHONY: translation

translation:
	for TRANSLATION in de en es fr he_IL it nl pl_PL pt_BR; do\
		/usr/bin/msgfmt conf/locale/$$TRANSLATION/LC_MESSAGES/packetfence.po\
		  --output-file conf/locale/$$TRANSLATION/LC_MESSAGES/packetfence.mo;\
	done

.PHONY: mysql-schema

mysql-schema:
	ln -f -s /usr/local/pf/db/pf-schema-X.Y.Z.sql /usr/local/pf/db/pf-schema.sql;

.PHONY: chown_pf

chown_pf:
	chown -R pf:pf *

.PHONY: fingerbank

fingerbank:
	rm -f /usr/local/pf/lib/fingerbank
	ln -s /usr/local/fingerbank/lib/fingerbank /usr/local/pf/lib/fingerbank \

.PHONY: systemd

systemd:
	cp /usr/local/pf/conf/systemd/packetfence* /usr/lib/systemd/system/
	systemctl daemon-reload

.PHONY: pf-dal

pf-dal:
	perl /usr/local/pf/addons/dev-helpers/bin/generator-data-access-layer.pl

devel: configurations conf/ssl/server.key conf/ssl/server.crt conf/local_secret bin/pfcmd raddb/certs/server.crt sudo translation mysql-schema raddb/sites-enabled fingerbank chown_pf permissions bin/ntlm_auth_wrapper conf/unified_api_system_pass

test:
	cd t && ./smoke.t

update_samsung_dns_filter:
	bash /usr/local/pf/addons/update-samsung-dns-filter.sh

=== go/Makefile ===
.PHONY: processor-sha

pfhttpd-sha:
	make NAME="pfhttpd" _pfhttpd

pfhttpd:
	make NAME="pfhttpd" _pfhttpd

_pfhttpd:
	cd caddy/caddy/caddy && \
	go build && \
	cd - && \
	mv caddy/caddy/caddy/caddy ${NAME}

pfhttpd-race:
	cd caddy/caddy/caddy && \
	go build -race && \
	cd - && \
	mv caddy/caddy/caddy/caddy pfhttpd-race

pfdhcp:
	cd dhcp && \
	go build && \
	cd - && \
	mv dhcp/dhcp pfdhcp

pfdns:
	cd coredns && \
	go build && \
	cd - && \
	mv coredns/coredns pfdns

pfstats:
	cd stats && \
        go build && \
        cd - && \
        mv stats/stats pfstats

pfdetect:
	cd detect && \
        go build && \
        cd - && \
        mv detect/detect pfdetect

.PHONY: clean-caddy-src

clean-caddy-src:
	find caddy/ -type f -exec sed -i.bak "s'github.com/mholt/caddy'github.com/inverse-inc/packetfence/go/caddy/caddy'g" {} \; ; find . -name '*.bak' -delete
	find caddy/caddy/ -name '*_test.go' -delete

.PHONY: go-env

go-env:
	/usr/local/pf/addons/dev-helpers/setup-go-env.sh

.PHONY: test

test:
	/usr/local/pf/t/pfconfig-test ;\
	PFCONFIG_TESTING=y govendor test ./...

.PHONY: clean-coredns-src

clean-coredns-src:
	find coredns/ -type f -exec sed -i.bak "s'github.com/mholt/caddy'github.com/inverse-inc/packetfence/go/caddy/caddy'g" {} \; ; find . -name '*.bak' -delete
	find coredns/ -type f -exec sed -i.bak "s'github.com/coredns/coredns'github.com/inverse-inc/packetfence/go/coredns'g" {} \; ; find . -name '*.bak' -delete
	find coredns/ -name '*_test.go' -delete

=== raddb/certs/Makefile ===
######################################################################
#
#	Make file to be installed in /etc/raddb/certs to enable
#	the easy creation of certificates.
#
#	See the README file in this directory for more information.
#
#	$Id: cc12464c6c7754aff2f0c8d6e116708c94ff2168 $
#
######################################################################

DH_KEY_SIZE	= 2048

#
#  Set the passwords
#
-include passwords.mk

######################################################################
#
#  Make the necessary files, but not client certificates.
#
######################################################################
.PHONY: all
all: index.txt serial dh server ca client

.PHONY: client
client: client.pem

.PHONY: ca
ca: ca.der

.PHONY: server
server: server.pem server.vrfy

.PHONY: verify
verify: server.vrfy client.vrfy

passwords.mk: server.cnf ca.cnf client.cnf
	@echo "PASSWORD_SERVER	= '$(shell grep output_password server.cnf | sed 's/.*=//;s/^ *//')'"		> $@
	@echo "PASSWORD_CA	= '$(shell grep output_password ca.cnf | sed 's/.*=//;s/^ *//')'"		>> $@
	@echo "PASSWORD_CLIENT	= '$(shell grep output_password client.cnf | sed 's/.*=//;s/^ *//')'"		>> $@
	@echo "USER_NAME	= '$(shell grep emailAddress client.cnf | grep '@' | sed 's/.*=//;s/^ *//')'"	>> $@
	@echo "CA_DEFAULT_DAYS  = '$(shell grep default_days ca.cnf | sed 's/.*=//;s/^ *//')'"			>> $@

######################################################################
#
#  Diffie-Hellman parameters
#
######################################################################
dh:
	openssl gendh -out dh -2 $(DH_KEY_SIZE)

######################################################################
#
#  Create a new self-signed CA certificate
#
######################################################################
ca.key ca.pem: ca.cnf
	@[ -f index.txt ] || $(MAKE) index.txt
	@[ -f serial ] || $(MAKE) serial
	openssl req -new -x509 -nodes -keyout ca.key -out ca.pem \
		-days $(CA_DEFAULT_DAYS) -config ./ca.cnf

ca.der: ca.pem
	openssl x509 -inform PEM -outform DER -in ca.pem -out ca.der

######################################################################
#
#  Create a new server certificate, signed by the above CA.
#
######################################################################
server.csr server.key: server.cnf
	openssl req -new  -out server.csr -nodes -keyout server.key -config ./server.cnf

server.crt: server.csr ca.key ca.pem
	openssl ca -batch -keyfile ca.key -cert ca.pem -in server.csr -out server.crt -extensions xpserver_ext -extfile xpextensions -config ./server.cnf

server.p12: server.crt
	openssl pkcs12 -export -in server.crt -inkey server.key -out server.p12  -passin pass:$(PASSWORD_SERVER) -passout pass:$(PASSWORD_SERVER)

server.pem: server.p12
	openssl pkcs12 -in server.p12 -out server.pem -passin pass:$(PASSWORD_SERVER) -passout pass:$(PASSWORD_SERVER)

.PHONY: server.vrfy
server.vrfy: ca.pem
	@openssl verify -CAfile ca.pem server.pem

######################################################################
#
#  Create a new client certificate, signed by the the above server
#  certificate.
#
######################################################################
client.csr client.key: client.cnf
	openssl req -new  -out client.csr -nodes -keyout client.key -config ./client.cnf

client.crt: client.csr ca.pem ca.key
	openssl ca -batch -keyfile ca.key -cert ca.pem -in client.csr -out client.crt -extensions xpclient_ext -extfile xpextensions -config ./client.cnf

client.p12: client.crt
	openssl pkcs12 -export -in client.crt -inkey client.key -out client.p12  -passin pass:$(PASSWORD_CLIENT) -passout pass:$(PASSWORD_CLIENT)

client.pem: client.p12
	openssl pkcs12 -in client.p12 -out client.pem -passin pass:$(PASSWORD_CLIENT) -passout pass:$(PASSWORD_CLIENT)
	cp client.pem $(USER_NAME).pem

.PHONY: client.vrfy
client.vrfy: ca.pem client.pem
	c_rehash .
	openssl verify -CApath . client.pem

######################################################################
#
#  Miscellaneous rules.
#
######################################################################
index.txt:
	@touch index.txt

serial:
	@echo '01' > serial

print:
	openssl x509 -text -in server.crt

printca:
	openssl x509 -text -in ca.pem

clean:
	@rm -f *~ *old client.csr client.key client.crt client.p12 client.pem

#
#	Make a target that people won't run too often.
#
destroycerts:
	rm -f *~ dh *.csr *.crt *.p12 *.der *.pem *.key index.txt* \
			serial*  *\.0 *\.1

=== debian/changelog ===
packetfence (8.3.0) unstable; urgency=low

  * Version 8.3.0

 -- Inverse <info@inverse.ca>  Wed, 09 Jan 2019 12:00:00 -0400

packetfence (8.2.0) unstable; urgency=low

  * Version 8.2.0

 -- Inverse <info@inverse.ca>  Wed, 07 Nov 2018 12:00:00 -0400

packetfence (8.1.0) unstable; urgency=low

  * Version 8.1.0

 -- Inverse <info@inverse.ca>  Thu, 09 Jul 2018 12:00:00 -0400

packetfence (8.0.0) unstable; urgency=low

  * Version 8.0.0

 -- Inverse <info@inverse.ca>  Thu, 26 Apr 2018 12:00:00 -0400

packetfence (7.4.0) unstable; urgency=low

  * Version 7.4.0

 -- Inverse <info@inverse.ca>  Thu, 25 Jan 2018 12:00:00 -0400

packetfence (7.3.0) unstable; urgency=low

  * Version 7.3.0

 -- Inverse <info@inverse.ca>  Mon, 25 Sep 2017 12:00:00 -0400

packetfence (7.2.0) unstable; urgency=low

  * Version 7.2.0

 -- Inverse <info@inverse.ca>  Mon, 10 Jul 2017 12:00:00 -0400

packetfence (7.1.0) unstable; urgency=low

  * Version 7.1.0

 -- Inverse <info@inverse.ca>  Thu, 01 Jun 2017 12:00:00 -0400

packetfence (7.0.0) unstable; urgency=low

  * Version 7.0.0

 -- Inverse <info@inverse.ca>  Wed, 19 Apr 2017 12:00:00 -0400

packetfence (6.5.1) unstable; urgency=low

  * Version 6.5.1

 -- Inverse <info@inverse.ca>  Thu, 23 Feb 2017 12:00:00 -0400

packetfence (6.5.0) unstable; urgency=low

  * Version 6.5.0

 -- Inverse <info@inverse.ca>  Mon, 30 Jan 2017 12:00:00 -0400

packetfence (6.4.0) unstable; urgency=low

  * Version 6.4.0

 -- Inverse <info@inverse.ca>  Wed, 16 Nov 2016 12:00:00 -0400

packetfence (6.3.0) unstable; urgency=low

  * Version 6.3.0

 -- Inverse <info@inverse.ca>  Wed, 05 Oct 2016 12:00:00 -0400

packetfence (6.2.1) unstable; urgency=low

  * Version 6.2.1

 -- Inverse <info@inverse.ca>  Fri, 08 Jul 2016 12:00:00 -0400

packetfence (6.2.0) unstable; urgency=low

  * Version 6.2.0

 -- Inverse <info@inverse.ca>  Tue, 05 Jul 2016 12:00:00 -0400

packetfence (6.1.1) unstable; urgency=low

  * Version 6.1.1

 -- Inverse <info@inverse.ca>  Tue, 22 Jun 2016 12:00:00 -0400

packetfence (6.1.0) unstable; urgency=low

  * Version 6.1.0

 -- Inverse <info@inverse.ca>  Tue, 21 Jun 2016 12:00:00 -0400

packetfence (6.0.3) unstable; urgency=low

  * Version 6.0.3

 -- Inverse <info@inverse.ca>  Thu, 02 Jun 2016 12:00:00 -0400

packetfence (6.0.2) unstable; urgency=low

  * Version 6.0.2

 -- Inverse <info@inverse.ca>  Thu, 26 May 2016 12:00:00 -0400

packetfence (6.0.1) unstable; urgency=low

  * Version 6.0.1

 -- Inverse <info@inverse.ca>  Thu, 28 Apr 2016 12:00:00 -0400

packetfence (6.0.0) unstable; urgency=low

  * Version 6.0.0

 -- Inverse <info@inverse.ca>  Tue, 19 Apr 2016 12:00:00 -0400

packetfence (5.7.0-1) unstable; urgency=low

  * Version 5.7.0

 -- Inverse <info@inverse.ca>  Wed, 17 Feb 2016 12:00:00 -0400

packetfence (5.6.0) unstable; urgency=low

  * Version 5.6.0

 -- Inverse <info@inverse.ca>  Wed, 13 Jan 2016 12:00:00 -0400

packetfence (5.5.1) unstable; urgency=low

  * Version 5.5.1

 -- Inverse <info@inverse.ca>  Fri, 27 Nov 2015 12:00:00 -0400

packetfence (5.5.0) unstable; urgency=low

  * Version 5.5.0

 -- Inverse <info@inverse.ca>  Fri, 20 Nov 2015 12:00:00 -0400

packetfence (5.4.0) unstable; urgency=low

  * Version 5.4.0

 -- Inverse <info@inverse.ca>  Thu, 01 Oct 2015 12:00:00 -0400

packetfence (5.3.0) unstable; urgency=low

  * Version 5.3.0

 -- Inverse <info@inverse.ca>  Tue, 21 Jul 2015 12:00:00 -0400

packetfence (5.2.0) unstable; urgency=low

  * Version 5.2.0

 -- Inverse <info@inverse.ca>  Thu, 18 Jun 2015 12:00:00 -0400

packetfence (5.1.0) unstable; urgency=low

  * Version 5.1.0

 -- Inverse <info@inverse.ca>  Tue, 26 May 2015 12:00:00 -0400

packetfence (5.0.2) unstable; urgency=low

  * Version 5.0.2

 -- Inverse <info@inverse.ca>  Fri, 01 May 2015 12:00:00 -0400

packetfence (5.0.1) unstable; urgency=low

  * Version 5.0.1

 -- Inverse <info@inverse.ca>  Wed, 22 Apr 2015 12:00:00 -0400

packetfence (5.0.0) unstable; urgency=low

  * Version 5.0.0

 -- Inverse <info@inverse.ca>  Wed, 15 Apr 2015 12:00:00 -0400

packetfence (4.7.0) unstable; urgency=low

  * Version 4.7.0

 -- Inverse <info@inverse.ca>  Fri, 06 Mar 2015 12:00:00 -0400

packetfence (4.6.1) unstable; urgency=low

  * Version 4.6.1

 -- Inverse <info@inverse.ca>  Thu, 19 Feb 2015 12:00:00 -0400

packetfence (4.6.0) unstable; urgency=low

  * Version 4.6.0

 -- Inverse <info@inverse.ca>  Wed, 04 Feb 2015 12:00:00 -0400

packetfence (4.5.1) unstable; urgency=low

  * Version 4.5.1

 -- Inverse <info@inverse.ca>  Mon, 10 Nov 2014 12:00:00 -0400

packetfence (4.5.0) unstable; urgency=low

  * Version 4.5.0

 -- Inverse <info@inverse.ca>  Wed, 22 Oct 2014 12:00:00 -0400

packetfence (4.4.0) unstable; urgency=low

  * Version 4.4.0

 -- Inverse <info@inverse.ca>  Wed, 10 Sep 2014 12:00:00 -0400

packetfence (4.3.0) unstable; urgency=low

  * Version 4.3.0

 -- Inverse <info@inverse.ca>  Thu, 26 Jun 2014 12:00:00 -0400

packetfence (4.2.2) unstable; urgency=low

  * Version 4.2.2

 -- Inverse <info@inverse.ca>  Tue, 29 May 2014 12:00:00 -0400

packetfence (4.2.1) unstable; urgency=low

  * Version 4.2.1

 -- Inverse <info@inverse.ca>  Tue, 16 May 2014 12:00:00 -0400

packetfence (4.2.0) unstable; urgency=low

  * Version 4.2.0

 -- Inverse <info@inverse.ca>  Tue, 6 May 2014 12:00:00 -0400

packetfence (4.1.0) unstable; urgency=low

  * Version 4.1.0

 -- Francis Lachapelle <flachapelle@inverse.ca>  Wed, 11 Dec 2013 12:00:00 -0400

packetfence (4.0.6) unstable; urgency=low

  * Version 4.0.6

 -- Francis Lachapelle <flachapelle@inverse.ca>  Thu, 5 Sep 2013 12:00:00 -0400

packetfence (4.0.5) unstable; urgency=low

  * Version 4.0.5

 -- Francis Lachapelle <flachapelle@inverse.ca>  Fri, 9 Aug 2013 12:00:00 -0400

packetfence (4.0.4) unstable; urgency=low

  * Version 4.0.4

 -- Francis Lachapelle <flachapelle@inverse.ca>  Mon, 5 Aug 2013 12:00:00 -0400

packetfence (4.0.3) unstable; urgency=low

  * Version 4.0.3



=== debian/control ===
Source: packetfence
Section: net
Priority: optional
Maintainer: Durand fabrice <fdurand@inverse.ca>
Build-Depends: debhelper (>= 7.0.50~), gettext, libparse-recdescent-perl, gcc, dpkg-distribution, dh-systemd, libfile-fcntllock-perl, asciidoctor, git, libipset-dev, pkg-config, nodejs (>= 8.0)
Standards-Version: 3.8.4
Vcs-Git: git://github.com/inverse-inc/packetfence.git
Vcs-browser: https://github.com/inverse-inc/packetfence/
Homepage: http://www.packetfence.org/

Package: packetfence
Architecture: all
# TODO: We can probably move these in Depends since 3.5.0 (managed RADIUS feature)
Pre-Depends:  ca-certificates, 
 ca-certificates, winbind,
 packetfence-pfcmd-suid (>= ${source:Version}), packetfence-config (>= ${source:Version}),
# CAUTION: we need to require the version we want for Fingerbank and ensure we don't want anything equal or above the next major release as it can add breaking changes
 fingerbank (>= 4.1.3), fingerbank (<< 5.0.0),
 fingerbank-collector (>= 1.1.0), fingerbank-collector (<< 2.0.0),
 packetfence-redis-cache (>= ${source:Version}),
 packetfence-pfappserver-javascript (>= ${source:Version}),
 packetfence-captive-portal-javascript (>= ${source:Version}),
# wmi
 libnet-wmiclient-perl, libwmiclient1, wmi-client,
 netdata (>= 1.10),
Breaks: libdata-alias-perl
Depends: ${misc:Depends}, vlan,
 packetfence-ntlm-wrapper (>= ${source:Version}), packetfence-doc (>= ${source:Version}), packetfence-golang-daemon (>= ${source:Version}),
 openssl, openssl-blacklist, openssl-blacklist-extra,
 mariadb-server (>= 10.1),
 snmp, snmptrapfmt, snmptrapd, snmp-mibs-downloader, conntrack,
# apache related
 apache2, apache2-utils, libapache2-mod-proxy-html,
 apache2-mpm-prefork, libapache2-mod-apreq2, libapache2-mod-perl2,
 libapache2-request-perl, libtie-dxhash-perl, libapache-session-perl,
 libapache-ssllookup-perl, libapache2-mod-systemd,
# freeradius
 freeradius (>= 3.0.18), freeradius-ldap,
 freeradius-mysql, freeradius-utils, freeradius-rest, freeradius-redis,
# systemd sd_notify support
 libsystemd-daemon-perl,
# binary
 make,
 samba,
 krb5-user,
 iproute,
 ipset,
 sudo,
 sscep,
 patch,
 git,
# process management
 procps,
# perl basic components
 liblist-moreutils-perl, libwww-perl, libtry-tiny-perl,
# perl uncategorized modules
 libapache-htpasswd-perl, libbit-vector-perl, libtext-csv-perl, libtext-csv-xs-perl,
 libcgi-session-serialize-yaml-perl, libtimedate-perl, libapache-dbi-perl,
 libdbd-mysql-perl, libfile-tail-perl, libnetwork-ipv4addr-perl,
 libiptables-parse-perl, libiptables-chainmgr-perl, iptables (>= 1.4.0),
 liblwp-useragent-determined-perl, 
 libnet-netmask-perl, libnet-pcap-perl, libnet-snmp-perl, libsnmp-perl, libfile-fcntllock-perl,
 libnet-telnet-cisco-perl, libparse-recdescent-perl, libnet-cisco-mse-rest-perl, perlmagick,
 libregexp-common-email-address-perl, libregexp-common-time-perl,
 libperl-critic-perl, libreadonly-xs-perl, libhtml-template-perl,
 libterm-readkey-perl, libtest-perl-critic-perl, libtest-pod-perl,
 libtest-pod-coverage-perl, libthread-pool-simple-perl,
 libuniversal-require-perl, libuniversal-exports-perl, libnet-rawip-perl,
 libcgi-session-perl, libcgi-session-driver-chi-perl (>= 1.0.3), libconfig-inifiles-perl (>= 2.88),
 libdatetime-format-dateparse-perl, libdatetime-format-rfc3339-perl, libdbi-perl,librose-db-perl,librose-db-object-perl,libdatetime-timezone-perl,
 libnet-telnet-perl, libregexp-common-perl,libhtml-formhandler-perl (>= 0.40019),
 libreadonly-perl, libtemplate-perl, libtemplate-autofilter-perl, libterm-readkey-perl,
 libuniversal-require-perl, libthread-serialize-perl,
 libnet-ldap-perl, libcrypt-generatepassword-perl, libbytes-random-secure-perl, libcrypt-eksblowfish-perl, libcrypt-smbhash-perl,
 libcrypt-cbc-perl, perl-doc, libcrypt-rijndael-perl,
 librrds-perl, libnetpacket-perl (>= 1.3), libcache-cache-perl, libcarp-perl,
 libload-perl, libmime-lite-tt-perl, libmime-lite-perl,
 libconfig-general-perl, libproc-processtable-perl, libperl-version-perl,
 perl-modules,libdata-swap-perl,libdata-structure-util-perl,
 liblinux-fd-perl, liblinux-inotify2-perl, libfile-touch-perl, libhash-merge-perl, libposix-atfork-perl,
 libcrypt-openssl-pkcs12-perl,libcrypt-openssl-x509-perl,libconst-fast-perl,
 libtime-period-perl (>= 1.25), libtime-piece-perl, libsereal-encoder-perl, libsereal-decoder-perl, libdata-serializer-sereal-perl (>= 1.04), libphp-serialization-perl,
 libnet-ip-perl, libdigest-hmac-perl, libcrypt-openssl-pkcs10-perl, libcrypt-openssl-rsa-perl, libfile-tempdir-perl,
 liburi-escape-xs-perl, libsql-abstract-more-perl (>= 1.28), libsql-abstract-plugin-insertmulti-perl, libio-socket-timeout-perl, liblinux-distribution-perl, libwww-twilio-api-perl,
 libpod-markdown-perl, libmojolicious-perl (>= 7.74), libmojox-log-log4perl-perl, liblingua-en-inflexion-perl,
# hard-coded to specific version because v3 broke the API and we haven't ported to it yet
# see #1313: Port our Net-Appliance-Session to the version 3 API
# http://packetfence.org/bugs/view.php?id=1313
 libnet-appliance-session-perl (>= 2.111080),
 libnet-ssh2-perl (>= 0.63),
 libnet-cli-interact-perl,
 libre-engine-re2-perl,
 libnet-interface-perl, libnet-radius-perl, libclass-xsaccessor-perl, libbsd-resource-perl,
 libparse-nessus-nbe-perl, libtest-mockdbi-perl,
 libsoap-lite-perl (>= 1.0), libnet-frame-perl, libthread-pool-perl,
 libwww-curl-perl, libposix-2008-perl, libdata-messagepack-stream-perl, libdata-messagepack-perl,
 libnet-nessus-xmlrpc-perl (>= 0.4), libnet-nessus-rest-perl (>= 0.7), libfile-slurp-perl,
 libalgorithm-combinatorics-perl,
# required for ipset
 libnetaddr-ip-perl, libfile-which-perl,
# FIXME track what requires the conveyor stuff and identify it. If we can, get rid of it.
 libthread-conveyor-monitored-perl, libthread-conveyor-perl, libthread-tie-perl,
 liberror-perl, libio-socket-inet6-perl,
 libio-interface-perl, libnet-route-perl, libnet-arp-perl,
# required by catalyst
 libcatalyst-perl (>= 5.90011), libcatalyst-modules-perl,
 libauthen-htpasswd-perl, libcatalyst-authentication-credential-http-perl, 
 libcatalyst-authentication-store-htpasswd-perl, libcatalyst-plugin-unicode-encoding-perl,
 libcatalyst-view-tt-perl (>= 0.37), libcatalyst-view-csv-perl, libhtml-formfu-perl, libjson-perl, libjson-maybexs-perl,
 libsort-naturally-perl, libchi-perl (>=0.59), libchi-memoize-perl,
 libdata-serializer-perl,
 libchi-driver-redis-perl,
 libredis-fast-perl,
 libcache-fastmmap-perl, libterm-size-any-perl,
 libswitch-perl,
# packaging workaround (we don't require it but something in catalyst seem to do)
 libmodule-install-perl,
# i18n
 liblocale-gettext-perl, 
# logging framework
 liblog-log4perl-perl (>=1.43),
 liblog-any-perl,
 liblog-any-adapter-perl,
 liblog-any-adapter-log4perl-perl,
# oauth2
 libnet-oauth2-perl (>=0.57),
# used by Captive Portal authentication modules
 libauthen-radius-perl (>=0.24), libauthen-krb5-simple-perl,
# used by bin/pftest
 libio-interactive-perl,
# cluster
 haproxy (>= 1.8), keepalived (>= 1.4.3), arping,
# monitoring
 fping, python-mysqldb,
# EAP TLS
 libcrypt-smime-perl, libnumber-range-perl,
# Captive Portal Dynamic Routing
 libgraph-perl,
# SAML
 liblasso-perl,
# PaloAlto syslog SSO
 libnet-syslog-perl,
# for packaging
 dpkg-distribution,
# Distribution specific
 ${packetfence:dist}
Description: PacketFence network registration / worm mitigation system
 PacketFence is an open source network access control (NAC) system.
 It can be used to effectively secure networks, from small to very large
 heterogeneous networks. PacketFence provides features such
 as
 * registration of new network devices
 * detection of abnormal network activities
 * isolation of problematic devices
 * remediation through a captive portal
 * registration-based and scheduled vulnerability scans.

Package: packetfence-doc
Architecture: all
Description: documentation for packetfence
 The package packetfence-doc contains the documentation files needed for the admin gui

Package: packetfence-test
Architecture: all
Depends: packetfence, libtest-mockmodule-perl,
 libtest-nowarnings-perl, libtest-mockobject-perl,
 libtest-exception-perl
Description: Test suite for packetfence
 The PacketFence package contains a suite of test for validate packetfence
 installation.

Package: packetfence-pfcmd-suid
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Replaces: packetfence (<< 3.6.0)
Breaks: packetfence (<< 3.6.0)
Description: C wrapper that replace perl-suid dependence
 perl 5.12 dropped suidperl support (packaged as suid-perl)

Package: packetfence-ntlm-wrapper
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C wrapper around the ntlm_auth utility to log authentication latency and success/failure.


Package: packetfence-remote-arp-sensor
Architecture: all
Depends: ${misc:Depends}, libfile-tail-perl, libconfig-inifiles-perl (>= 2.88),
 libio-socket-ssl-perl, libxml-parser-perl, libcrypt-ssleay-perl,
 libnet-pcap-perl, libcache-memcached-libmemcached-perl, memcached,
# FIXME track what requires the conveyor stuff and identify it. If we can, get rid of it.
 libsoap-lite-perl, libthread-conveyor-monitored-perl, libthread-conveyor-perl
Conflicts: packetfence
Description: Files needed for sending MAC and IP from ARP requeststo
 PacketFence server. 

Package: packetfence-config
Architecture: all
Depends: ${misc:Depends}, libcache-bdb-perl, liblog-fast-perl, libfile-flock-perl, dpkg-distribution
Description: Service use to manage PacketFence configuration.

Package: packetfence-redis-cache
Architecture: all
Depends: ${misc:Depends}, redis-server, redis-tools, dpkg-distribution
Description: Init script to manage redis server.

Package: packetfence-golang-daemon
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: PacketFence Golang binary.
Conflicts: packetfence (<= 8.0.1)

Package: packetfence-captive-portal-javascript
Architecture: any
Depends: ${misc:Depends}
Description: PacketFence captive portal javascript
Conflicts: packetfence (<< 8.1.1)

Package: packetfence-pfappserver-javascript
Architecture: any
Depends: ${misc:Depends}
Description: PacketFence Admin javascript css
Conflicts: packetfence (<< 8.1.1)

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
NAME		= pf
PREFIX		= /usr/local
INSTALL		= /usr/bin/install -c -D -m0644

wheezy := $(shell (dpkg-distribution --is_wheezy && echo "yes") || echo "no")
jessie := $(shell (dpkg-distribution --is_jessie && echo "yes") || echo "no")
precise:= $(shell (dpkg-distribution --is_precise && echo "yes") || echo "no")

configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.

	touch configure-stamp


build: build-stamp

build-stamp: configure-stamp  
	dh_testdir


	touch $@

clean: 
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp


	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	#copying example files with the extention
	for i in `find * -name "*.example" ! -path 'conf/pfconfig.conf*' ! -path 'conf/redis_cache.conf*'`; do \
		$(INSTALL) $$i "$(CURDIR)/debian/packetfence$(PREFIX)/$(NAME)/$$(dirname $$i)/$$(basename $$i .example)"; \
	done

	# Install all except debian and t directory
	for i in `find * ! -path 'debian/*' ! -path 'debian' ! -path 't/*' ! -path 't' ! -path 'lib/pfconfig/*' ! -path 'lib/pfconfig' ! -path 'sbin/pfconfig' -type d`; do \
		install -d -m0700 $(CURDIR)/debian/packetfence$(PREFIX)/$(NAME)/$$i; \
	done
	for i in `find * ! -path 'debian/*' ! -path 'debian' ! -path 't/*' ! -path 't' ! -path 'lib/pfconfig/*' ! -path 'lib/pfconfig' ! -path 'sbin/pfconfig' ! -path 'conf/pfconfig.conf*' ! -path 'conf/redis_cache.conf*' ! -type d`; do \
		$(INSTALL) $$i $(CURDIR)/debian/packetfence$(PREFIX)/$(NAME)/$$i; \
	done
	for i in `find * -path 't*' -type d`; do \
		install -d -m0700 $(CURDIR)/debian/packetfence-test$(PREFIX)/$(NAME)/$$i; \
	done
	for i in `find * -path 't*' ! -type d`; do \
		$(INSTALL) $$i $(CURDIR)/debian/packetfence-test$(PREFIX)/$(NAME)/$$i; \
	done
	for i in `find * -path 'lib/pfconfig*' -type d`; do \
		install -d -m0700 $(CURDIR)/debian/packetfence-config$(PREFIX)/$(NAME)/$$i; \
	done
	for i in `find * -path 'lib/pfconfig/*' ! -type d`; do \
		$(INSTALL) $$i $(CURDIR)/debian/packetfence-config$(PREFIX)/$(NAME)/$$i; \
	done
	# generate translations
	# TODO this is duplicated in our RPM spec, we should aim to consolidate in a 'make' style step
	for TRANSLATION in de en es fr he_IL it nl pl_PL pt_BR; do \
		/usr/bin/msgfmt $(CURDIR)/debian/packetfence$(PREFIX)/$(NAME)/conf/locale/$$TRANSLATION/LC_MESSAGES/packetfence.po \
		--output-file $(CURDIR)/debian/packetfence$(PREFIX)/$(NAME)/conf/locale/$$TRANSLATION/LC_MESSAGES/packetfence.mo; \
	done
	# Install empty directories not in our tarball since the git move
	install -d -m0700 $(CURDIR)/debian/packetfence$(PREFIX)/$(NAME)/addons
	install -d -m0700 $(CURDIR)/debian/packetfence$(PREFIX)/$(NAME)/conf/ssl
	install -d -m0700 $(CURDIR)/debian/packetfence$(PREFIX)/$(NAME)/raddb/sites-enabled
	install -d -m2770 $(CURDIR)/debian/packetfence$(PREFIX)/$(NAME)/logs
	install -d -m2770 $(CURDIR)/debian/packetfence$(PREFIX)/$(NAME)/var/conf
	install -d -m2770 $(CURDIR)/debian/packetfence$(PREFIX)/$(NAME)/var/cache
	install -d -m2770 $(CURDIR)/debian/packetfence$(PREFIX)/$(NAME)/var/cache/ntlm_cache_users
	install -d -m2770 $(CURDIR)/debian/packetfence$(PREFIX)/$(NAME)/var/var
	install -d -m2770 $(CURDIR)/debian/packetfence$(PREFIX)/$(NAME)/var/redis_queue
	install -d -m2770 $(CURDIR)/debian/packetfence$(PREFIX)/$(NAME)/var/redis_ntlm_cache
	install -d -m2770 $(CURDIR)/debian/packetfence$(PREFIX)/$(NAME)/var/run
	install -d -m0700 $(CURDIR)/debian/packetfence$(PREFIX)/$(NAME)/var/rrd
	install -d -m2770 $(CURDIR)/debian/packetfence$(PREFIX)/$(NAME)/var/session
	install -d -m0700 $(CURDIR)/debian/packetfence$(PREFIX)/$(NAME)/var/webadmin_cache
	install -d -m2770 $(CURDIR)/debian/packetfence$(PREFIX)/$(NAME)/var/cache/configfiles
	install -d -m2770 $(CURDIR)/debian/packetfence$(PREFIX)/$(NAME)/var/cache/configfilesdata
#ifeq ($(jessie),yes)
	install -d -m0700 $(CURDIR)/debian/packetfence$(PREFIX)/$(NAME)/var/ssl_mutex
#endif
	touch $(CURDIR)/debian/packetfence$(PREFIX)/$(NAME)/var/cache_control
	#Configurator integration
#ifneq (,$(filter yes,$(wheezy) $(precise)))
#	install -d -m0700 $(CURDIR)/debian/packetfence/etc/init.d
#endif
#ifeq ($(jessie),yes)
	install -d -m0700 $(CURDIR)/debian/packetfence/lib/systemd/system
	install -d -m0700 $(CURDIR)/debian/packetfence/etc/systemd/system
	install -m0644 $(CURDIR)/debian/packetfence.target $(CURDIR)/debian/packetfence/etc/systemd/system
	install -m0644 $(CURDIR)/debian/packetfence-base.target $(CURDIR)/debian/packetfence/etc/systemd/system
	install -m0644 $(CURDIR)/debian/packetfence-cluster.target $(CURDIR)/debian/packetfence/etc/systemd/system
	install -d -m0700 $(CURDIR)/debian/packetfence/etc/systemd/system/packetfence-base.target.wants
	install -d -m0700 $(CURDIR)/debian/packetfence/etc/systemd/system/packetfence.target.wants
	install -d -m0700 $(CURDIR)/debian/packetfence/etc/systemd/system/packetfence-cluster.target.wants
	install -m0644 $(CURDIR)/debian/packetfence.slice $(CURDIR)/debian/packetfence/etc/systemd/system
	install -m0644 $(CURDIR)/debian/packetfence-base.slice $(CURDIR)/debian/packetfence/etc/systemd/system
	install -m0644 $(CURDIR)/debian/ifup@.service $(CURDIR)/debian/packetfence/etc/systemd/system
#endif
	install -d -m0700 $(CURDIR)/debian/packetfence/etc/default
	# copy the rsyslog systemd drop in
	install -d -m0755 $(CURDIR)/debian/packetfence/etc/systemd/system/rsyslog.service.d/
	install -m0600 $(CURDIR)/packetfence.rsyslog-drop-in.service  $(CURDIR)/debian/packetfence/etc/systemd/system/rsyslog.service.d/packetfence.conf
	#Sudoer
	install -oroot -groot -d -m0750 $(CURDIR)/debian/packetfence/etc/sudoers.d
	install -oroot -groot -m0440 $(CURDIR)/debian/packetfence.sudoers $(CURDIR)/debian/packetfence/etc/sudoers.d/packetfence
	rm -fr $(CURDIR)/debian/packetfence$(PREFIX)/$(NAME)/html/pfappserver/root/static/alt
	#PacketFence remote ARP sensor
	install -d -m0700 $(CURDIR)/debian/packetfence-remote-arp-sensor$(PREFIX)/$(NAME)/conf
	install -d $(CURDIR)/debian/packetfence-remote-arp-sensor$(PREFIX)/$(NAME)/var
	install -d $(CURDIR)/debian/packetfence-remote-arp-sensor$(PREFIX)/$(NAME)/var/run
	install -d $(CURDIR)/debian/packetfence-remote-arp-sensor$(PREFIX)/$(NAME)/sbin
	install -m0755 addons/pfarp_remote/sbin/pfarp_remote $(CURDIR)/debian/packetfence-remote-arp-sensor$(PREFIX)/$(NAME)/sbin
	install -m0600 addons/pfarp_remote/conf/pfarp_remote.conf $(CURDIR)/debian/packetfence-remote-arp-sensor$(PREFIX)/$(NAME)/conf
	#PacketFence pfcmd suid
	install -d -m0755 $(CURDIR)/debian/packetfence-pfcmd-suid$(PREFIX)/$(NAME)/bin
	gcc src/pfcmd.c -o $(CURDIR)/debian/packetfence-pfcmd-suid$(PREFIX)/$(NAME)/bin/pfcmd
	# ntlm-wrapper
	install -d -m0755 $(CURDIR)/debian/packetfence-ntlm-wrapper$(PREFIX)/$(NAME)/bin
	make bin/ntlm_auth_wrapper
	mv bin/ntlm_auth_wrapper $(CURDIR)/debian/packetfence-ntlm-wrapper$(PREFIX)/$(NAME)/bin
	# packetfence-config
	install -d $(CURDIR)/debian/packetfence-config$(PREFIX)/$(NAME)/sbin
#ifeq ($(jessie),yes)
	install -d -m0700 $(CURDIR)/debian/packetfence-config/lib/systemd/system
#endif
	install -d -m0700 $(CURDIR)/debian/packetfence-config$(PREFIX)/$(NAME)/conf
	install -d -m2770 $(CURDIR)/debian/packetfence-config$(PREFIX)/$(NAME)/var/cache/pfconfig
	install -m0755 sbin/pfconfig $(CURDIR)/debian/packetfence-config$(PREFIX)/$(NAME)/sbin
	install -m0600 conf/pfconfig.conf.example $(CURDIR)/debian/packetfence-config$(PREFIX)/$(NAME)/conf/pfconfig.conf
	# packetfence-redis-cache
#ifneq (,$(filter yes,$(wheezy) $(precise)))
#	install -d -m0700 $(CURDIR)/debian/packetfence-redis-cache/etc/init.d
#endif
